<?php

namespace Runtime\Http\View;

use Runtime\Factory\AppFactory;
use Twig\Environment;
use Twig\Loader\FilesystemLoader;
use Twig\TwigFunction;

class ViewEngine extends AppFactory {

    /**
     * @var Environment
     */
    private static $instance;

    public function __construct()
    {
        $loader = new FilesystemLoader(app()->resourcePath()  . 'views');

        self::$instance = new Environment($loader, [
            //'cache' => app()->resourcePath() . 'cache'
        ]);

        $this->loadHelperFunctions();
    }

    /**
     * Load all helper functions as Twig Function
     */
    private function loadHelperFunctions()
    {
        $functions = $this->getHelperFunctions();

        foreach ($functions as $function)
        {
            $function = new TwigFunction($function, function (...$params) use ($function) {
                return call_user_func_array($function, $params);
            });

            self::$instance->addFunction($function);
        }
    }

    /**
     * @return Environment
     */
    public static function get()
    {
        return self::$instance;
    }

}